/*
 *	TOPPERS/ASP Kernel
 *		Toyohashi Open Platform for Embedded Real-Time Systems/
 *		Advanced Standard Profile Kernel
 *	
 *	Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *				Graduate School of Information Science, Nagoya Univ., JAPAN
 *	Copyright (C) 2007-2011 by Industrial Technology Institute,
 *								Miyagi Prefectural Government, JAPAN
 *	
 *	嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *	ܥեȥѤΤޤࡥʲƱˤѡʣ
 *	ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *	(1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *		ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *		˴ޤޤƤ뤳ȡ
 *	(2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *		ѤǤǺۤˤϡۤȼɥȡ
 *		ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *		̵ݾڵǺܤ뤳ȡ
 *	(3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *		ѤǤʤǺۤˤϡΤ줫ξ
 *		ȡ
 *	  (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *		  ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *	  (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *		  𤹤뤳ȡ
 *	(4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *		⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *		ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *		ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *		դ뤳ȡ
 *	
 *	ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *	TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *	ФŬޤơʤݾڤԤʤޤܥեȥ
 *	ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *	Ǥʤ
 *	
 *	$Id: prc_config.h 2216 2011-08-08 02:41:49Z mit-kimai $
 */

/*
 *		ץå¸⥸塼SH12Aѡ
 *
 *	Υ󥯥롼ɥեϡtarget_config.hʤޤϡ饤
 *	롼ɤեˤΤߤ饤󥯥롼ɤ롥¾Υե뤫
 *	ľܥ󥯥롼ɤƤϤʤʤ
 */

#ifndef TOPPERS_PRC_CONFIG_H
#define TOPPERS_PRC_CONFIG_H

#ifndef TOPPERS_TARGET_CONFIG_H
#error  target_config.h is not included!
#endif	/*  TOPPERS_TARGET_CONFIG_H  */

/*
 *  顼åˡλ
 */
#define CHECK_STKSZ_ALIGN	4	/* åΥ饤ñ */
#define CHECK_FUNC_ALIGN	2	/* ؿΥ饤ñ */
#define CHECK_FUNC_NONNULL		/* ؿNULLå */
#define CHECK_STACK_ALIGN	4	/* åΰΥ饤ñ */
#define CHECK_STACK_NONNULL		/* åΰNULLå */
#define CHECK_MPF_ALIGN		4	/* ĹסΰΥ饤ñ */
#define CHECK_MPF_NONNULL		/* ĹסΰNULLå */
#define CHECK_MB_ALIGN		4	/* ΰΥ饤ñ */


#ifndef TOPPERS_MACRO_ONLY

/*
 *	ץåü̿Υ饤ؿ
 */
#include "prc_insn.h"

/*
 *	ȥ(start.S)
 */
extern void start(void);

/*
 *	̤ϿγѤΥȥ
 */
extern void default_int_handler_entry(void);

/*
 *	󥿥ƥѤΥå
 */
#define TOPPERS_ISTKPT(istk, istksz) ((STK_T *)((char_t *)(istk) + (istksz)))

/*
 *	ƥȥ֥å
 */
typedef struct task_context_block {
	void	*sp;		/* åݥ */
	FP		pc;			/* ץ५ */
} TSKCTXB;


#define USE_TSKINICTXB	/*  TSKINICTXBѤ  */

/*
 *	ƥȥ֥å
 */
typedef struct task_initialization_context_block {
	SIZE	stksz;			/* åΰΥʴݤ᤿͡ */
	void	*stk_bottom;	/* åݥ󥿤ν͡ʥåν͡ */
} TSKINICTXB;


#endif /* TOPPERS_MACRO_ONLY */

/*
 *	ͥ٥ޥ饤֥
 *	
 *	SH12AǤϡơ쥸SRˤ47ӥåܤ4ӥåȤ˳
 *	ͥ٥ޥʥϡɥγͥ٥ޥIPMˤ֤Ƥ
 *	롥IPM¸Ƥˡͥ٤γɽ-1Ϣ³
 *	͡ˤȤȤǽǤ뤬;פʺӥåȥեȤȿ
 *	žɬפˤʤ롥򤱤뤿ˡIPM¸ˤϡSR47
 *	ӥåܤФͤȤȤˤ롥ͤͥ٥ޥ
 *	ɽȸƤӡIIPMȽ񤯤Ȥˤ롥
 */

/*
 *	ͥ٥ޥγɽɽѴ
 *
 *	֥Υե뤫饤󥯥롼ɤΤˡCAST
 */
#define EXT_IPM(iipm)	 (-CAST(PRI,(iipm) >> 4))		/* ɽɽ */
#define INT_IPM(ipm)	 (CAST(uint32_t, -(ipm)) << 4)	/* ɽɽ */

#ifndef TOPPERS_MACRO_ONLY

/*
 *	IPMʥϡɥγͥ٥ޥɽˤθͤɽФ
 */
Inline uint32_t
current_iipm(void)
{
	return((uint32_t)(current_sr() & 0xF0U));
}

/*
 *	IPMʥϡɥγͥ٥ޥɽˤθͤ
 */
Inline void
set_iipm(uint32_t iipm)
{
	set_sr((current_sr() & ~0xF0U) | iipm);
}

Inline void
set_iipm_with_nop(uint32_t iipm)
{
	set_sr_with_nop((current_sr() & ~0xF0U) | iipm);
}

/*
 *	TOPPERSɸ߽ǥμ¸
 *
 *	SH12Aϥơ쥸(SR)˳ͥ٥ޥ(IPM)äƤ롥
 *	CPUåե饰ǽʤΤᡤŪCPUå
 *	饰¸롥
 *
 *	ޤCPUå֤ѿ(lock_flag)Ѱդ롥
 *
 *	CPUåե饰ꥢƤ֤ϡIPMǥγͥ
 *	ޥͤꤹ롥δ֤ϡǥγͥ٥ޥϡ
 *	IPMѤ롥
 *	
 *	ФCPUåե饰åȤƤ֤ϡIPM򡤥ͥ
 *	ΤΤ٤Ƥγ׵ޥ(TIPM_LOCK)ȡ
 *	γͥ٥ޥȤι⤤ꤹ롥δ֤Υǥγ
 *	ͥ٥ޥϡΤѿ(saved_iipm, ɽݻ)
 *	դݻ롥
 *
 *	ФCPUåե饰åȤƤ֤ϡ
 *	 IPM򡤥ͥΤΤ٤Ƥγ׵ޥ
 *	 (TIPM_LOCK)
 *	 ǥγͥ٥ޥ
 *	ΣĤ⡢⤤ꤹ롥δ֤Υǥγͥ٥ޥ
 *	ϡΤѿ(saved_iipm, ɽݻ)Ѱդݻ롥
 *	ƥȤǤϡCPUåְʳǤϡsaved_iipmϾIPM
 *	Ʊͤˤʤ褦ˤ롥
 */

/*
 *	ƥȻȤΤѿ
 *
 *	㳰ʳ/CPU㳰ˤΥͥȲΥ
 *	
 */
extern uint32_t excnest_count;

/*
 *	ƥȤλ
 *
 *	SH12AǤϡƥȤȽ˳/CPU㳰ΥͥȲѤ
 *	
 */
Inline bool_t
sense_context(void)
{
	return(excnest_count > 0U);
}

#endif /* TOPPERS_MACRO_ONLY */

/*
 *	CPUå֤Ǥγͥ٥ޥ
 *
 *	TIPM_LOCKϡCPUå֤Ǥγͥ٥ޥʤ
 *	ΤΤ٤Ƥγߤޥͤ롥
 */
#define TIPM_LOCK	 TMIN_INTPRI

/*
 *	CPUå֤Ǥγͥ٥ޥɽ
 */
#define IIPM_LOCK	 INT_IPM(TIPM_LOCK)

/*
 *	ͥ٥ޥTIPM_ENAALLˤɽ
 */
#define IIPM_ENAALL  INT_IPM(TIPM_ENAALL)

/*
 *	ߥåɽ
 */
#define IIPM_DISALL  UINT_C(0xf0)

#ifndef TOPPERS_MACRO_ONLY

/*
 *	CPUåե饰¸Τѿ
 *	
 *	ѿϡCPUå֤λΤ߽񤭴Ƥ褤Ȥ롥
 */
extern bool_t	lock_flag;	 /* CPUåե饰ͤݻѿ */
extern uint32_t saved_iipm;  /* ͥ٤ޥѿ */

/*
 *	CPUå֤ؤΰܹ
 *
 *	IPMʥϡɥγͥ٥ޥˤsaved_iipm¸
 *	ͥΤΤ٤Ƥγߤޥ͡TIPM_LOCKˤ
 *	ꤹ롥ޤlock_flagtrueˤ롥
 *
 *	IPMǽ餫TIPM_LOCKƱ⤤ˤϡ
 *	saved_iipm¸ΤߤǡTIPM_LOCKˤꤷʤϡǥ
 *	γͥ٥ޥTIPM_LOCKƱ⤤٥
 *	Ƥ֤ˤ롥
 *
 *	δؿϡCPUå֡lock_flagtrueξ֡ˤǸƤФ뤳Ȥ
 *	ʤΤꤷƤ롥
 */
Inline void
x_lock_cpu(void)
{
	uint32_t iipm;

	/*
	 *	current_iipm()֤ͤľsaved_iipm¸ѿiipm
	 *	ѤƤΤϡcurrent_iipm()Ƥľ˳ߤȯ
	 *	ư줿߽saved_iipmѹǽ뤿
	 *	롥
	 */
	iipm = current_iipm();
	if (IIPM_LOCK > iipm) {
		set_iipm(IIPM_LOCK);
	}
	saved_iipm = iipm;
	lock_flag = true;
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("":::"memory");
}

#define t_lock_cpu()	x_lock_cpu()
#define i_lock_cpu()	x_lock_cpu()

/*
 *	CPUå֤β
 *
 *	lock_flagfalseˤIPMʥϡɥγͥ٥ޥˤ
 *	saved_iipm¸᤹ͤ
 *
 *	δؿϡCPUå֡lock_flagtrueξ֡ˤǤΤ߸ƤФ
 *	ΤꤷƤ롥
 */
Inline void
x_unlock_cpu(void)
{
	/* ƥ륻ǥ꤬񤭴ǽ */
	Asm("":::"memory");
	lock_flag = false;
	set_iipm_with_nop(saved_iipm);
}

#define t_unlock_cpu()	  x_unlock_cpu()
#define i_unlock_cpu()	  x_unlock_cpu()

/*
 *	CPUå֤λ
 */
Inline bool_t
x_sense_lock(void)
{
	return(lock_flag);
}

#define t_sense_lock()	  x_sense_lock()
#define i_sense_lock()	  x_sense_lock()

/*
 *	chg_ipmͭʳͥ٤ϰϤȽ
 *
 *	TMIN_INTPRIͤˤ餺chg_ipmǤϡ-15TIPM_ENAALLʡ0ˤϰ
 *	Ǥ뤳ȤȤʥåγĥˡ
 */
#define VALID_INTPRI_CHGIPM(intpri) \
				((-15 <= (intpri)) && ((intpri) <= TIPM_ENAALL))

/*
 * ʥǥΡ˳ͥ٥ޥ
 *
 *	CPUåե饰ꥢƤϡϡɥγͥ٥
 *	ꤹ롥
 *	
 *	CPUåե饰åȤƤϡϡɥγͥ٥
 *	ꤷ褦ȤʥǥΡ˳ͥ٥ޥTIPM_LOCK
 *	ι⤤ꤹ롥
 *
 */
Inline void
x_set_ipm(PRI intpri)
{
	uint32_t   iipm = INT_IPM(intpri);

	
	if (!lock_flag) {
		set_iipm(iipm);
	}
	else {
		/*
		 *	CPUå֤ʤΤǡͥγߤʤ
		 *	saved_iipmʤ
		 */
		saved_iipm = iipm;
#if TIPM_LOCK == -15
		/*
		 *	TIPM_LOCK-15ξˤϡλǥϡɥγͥ
		 *	٥ޥɬ15ꤵƤ뤿ᡤꤷľɬפʤ
		 */
#else /* TIPM_LOCK == -15 */
		set_iipm((iipm > IIPM_LOCK) ? iipm : IIPM_LOCK);
#endif /* TIPM_LOCK == -15 */
	}
}

#define t_set_ipm(intpri)	 x_set_ipm(intpri)
#define i_set_ipm(intpri)	 x_set_ipm(intpri)

/*
 * ʥǥΡ˳ͥ٥ޥλ
 *
 *	CPUåե饰ꥢƤϥϡɥγͥ٥
 *	򡤥åȤƤsaved_iipm򻲾Ȥ롥
 */
Inline PRI
x_get_ipm(void)
{
	uint32_t iipm;

	if (!lock_flag) {
		iipm = current_iipm();
	}
	else {
		iipm = saved_iipm;
	}
	return(EXT_IPM(iipm));
}

#define t_get_ipm()    x_get_ipm()
#define i_get_ipm()    x_get_ipm()

/*
 *	ǹ̥ͥؤΥǥѥåprc_support.S
 *
 *	dispatchϡƥȤƤӽФ줿ӥ
 *	ƤӽФ٤Τǡ
 *	 ƥ
 *	 CPUå
 *	 ǥѥåľ
 *	 ʥǥΡ˳ͥ٥ޥ
 *	ǸƤӽФʤФʤʤ
 */
extern void dispatch(void);

/*
 *	ǥѥåưϡprc_support.S
 *
 *	start_dispatchϡͥ뵯ư˸ƤӽФ٤Τǡ٤Ƥγ
 *	ߤػߤ֡ߥå֤Ʊξ֡ˤǸƤӽФʤ
 *	ʤʤ
 */
extern void start_dispatch(void) NoReturn;

/*
 *	ߤΥƥȤΤƤƥǥѥåprc_support.S
 *
 *	exit_and_dispatchϡext_tskƤӽФ٤Τǡ
 *	 ƥ
 *	 CPUå
 *	 ǥѥåľ
 *	 ʥǥΡ˳ͥ٥ޥ
 *	ǸƤӽФʤФʤʤ
 */
extern void exit_and_dispatch(void) NoReturn;

/*
 *	ͥνλθƽФprc_support.S
 *
 *	call_exit_kernelϡͥνλ˸ƤӽФ٤Τǡ󥿥
 *	ƥȤڤ괹ơͥνλexit_kernelˤƤӽ
 *	
 */
extern void call_exit_kernel(void) NoReturn;

/*
 *	ƥȤν
 *
 *	ٻ߾֤¹ԤǤ֤˰ܹԤ˸ƤФ롥λ
 *	ǥåΰȤäƤϤʤʤ
 *
 *	activate_context򡤥饤ؿǤϤʤޥȤƤΤϡ
 *	λǤTCBƤʤǤ롥
 */
extern void    start_r(void);

#define activate_context(p_tcb) 										\
{																		\
	(p_tcb)->tskctxb.sp = (p_tcb)->p_tinib->tskinictxb.stk_bottom;		\
	(p_tcb)->tskctxb.pc = (FP)start_r;									\
}

/*
 *	calltexϻѤʤ
 */
#define OMIT_CALLTEX

/*
 * å¸˴ޤޤɸ㳰ǽνѤʤ
 */
#define OMIT_INITIALIZE_EXCEPTION

/*
 * CPU㳰ϥɥν
 * ޥˤasp/kernel/exception.hǥץȥ
 * Ƥ뤿ᡢؿȤʤФʤʤ
 */
extern void initialize_exception(void);

/*
 *	SH12Aγߥƥȳ߽ǥμ¸
 */

/*
 *	ͥ
 *
 *	Ƴߤγͥ٤ϳͥ٥쥸(IPRXX)ˤ
 *	ꤹ롥ΤᡤƳ׵饤ˤɤγͥ٥
 *	쥸ΤɤΥեɤбƤ뤫ξIPR_INFOˤ
 *	ơ֥ipr_info_tbl[]Ѱդ롥
 *	ֹϢ³ƤʤᡤݡȤƤʤֹˤϡ
 *	addressȥ0ꤷˤֹȽ̤Ǥ
 *	롣
 *	ʥݡȤֹϥץꥱˤ餺ץå
 *	ϡɥͤˤäƷޤΤǡǡȤݻ롣
 *	Υơ֥ΥǥåˤϡֹɽѤ롣
 */

/*
 *	ƳֹꤹIPRξΤι¤
 *	
 *	ݡȤʤֹξϡaddressȥ0ꤹ롣
 *	
 *	offset8ӥåȤнʬͳ32ӥåȤˤ
 *	롣
 *	ι¤Τˤȷ֤Ǥǡ
 *	ʤʤ
 *	SHǤ32ӥåȥǡǤʤ̵̤̿᤬롣
 */
typedef struct {
	/* ͥ٥쥸Υɥ쥹 */
	uint32_t address;
	/* եå */
	uint32_t  offset;
} IPR_INFO;

/*
 *	ƳֹIPRξơ֥
 */
extern const IPR_INFO ipr_info_tbl[TNUM_INH];

/*
 *	ֹ桦ߥϥɥֹ
 *
 *	ߥϥɥֹ(inhno)ȳֹ(intno)ϡ٥ֹѤ롥
 *
 *	٥ֹTMIN_INTNO(=64)Ϥޤ뤿ᡤΤޤޤͤͥٴ
 *	Υơ֥ΥǥåѤȡ̵̤ΰ褬ȯ롥
 *	ΤᡤͥǤϡTMIN_INTNO򺹤͡ɽ
 *	Ѥ롥
 *
 *	ɽ̾ϡiintno,iinhnoȤ롥
 */

/*
 * ߥϥɥֹɽѴ
 */
											/* ɽɽ */
#define EXT_INHNO(iintno) (CAST(uint32_t, (iinhno) + TMIN_INHNO))
											/* ɽɽ */
#define INT_INHNO(intno)  (CAST(uint32_t, (inhno) - TMIN_INHNO))

/*
 * ֹɽѴ
 */
											/* ɽɽ */
#define EXT_INTNO(iintno)	(CAST(uint32_t, (iintno) + TMIN_INTNO))
											/* ɽɽ */
#define INT_INTNO(intno)	(CAST(uint32_t, (intno) - TMIN_INTNO))


/*
 *	ֹϰϤȽ
 *	
 *	TMIN_INTNOTMAX_INTNOϰϤǤäƤֹͭǤʤ礬뤿
 *	ᡤipr_info_tbl[]ֹͭ椫å
 */
#define VALID_INTNO_IPR(intno) \
		((TMIN_INTNO <= (intno)) && ((intno) <= TMAX_INTNO) 		\
			&& (ipr_info_tbl[INT_INTNO(intno)].address != 0U))
#define VALID_INTNO_DISINT(intno)	 VALID_INTNO_IPR(intno)
#define VALID_INTNO_CFGINT(intno)	 (VALID_INTNO_IPR(intno)		\
										|| ((intno) == TINTNO_NMI))

/*
 *	CPU㳰ϥɥֹ
 *
 *	CPU㳰ϥɥֹȤƤϡ٥ֹѤ롥
 *	ݡȤCPU㳰ϥɥϥץåη˰ۤʤΤǡץ
 *	åηե롥
 *	
 *	TMIN_EXCNOTMAX_EXCNOϰϤǤäƤֹͭǤʤ礬뤬
 *	åάƤ롣
 *
 */
#define VALID_EXCNO_DEFEXC(excno) \
		((TMIN_EXCNO <= (excno)) && ((excno) <= TMAX_EXCNO))

/*
 *	ߥϥɥ
 *
 *	ߥϥɥֹinhnoγߥϥɥεưint_entry
 *	ꤹ롥
 */
Inline void
x_define_inh(INHNO inhno, FP int_entry)
{
}

/*
 *	ߥϥɥνޥ
 *
 */
#define INT_ENTRY(inhno, inthdr)	 _kernel_##inthdr##_##inhno
#define INTHDR_ENTRY(inhno, inhno_num, inthdr)					\
		extern void _kernel_##inthdr##_##inhno(void);

/*
 *	׵ػߥե饰
 *
 *	SH12AIRCϳ׵ػߥե饰ʤߤ̤˶ػߤ
 *	ϡͥ٥쥸(IPRXX)0ꤹɬפ롥
 *	ͥ٥쥸0ˤ뤳Ȥǳ׵ػߥե饰
 *	¸ȡδ֡ǥγͥ٤򵭲Ƥΰ褬ɬ
 *	Ȥʤ롥ե졼ǤΤuint8_tΥơ֥
 *	int_iipm_tbl[]Ѱդ롥
 *	ͥ٤ꤵƤ뤫ɤϥӥå7ݻ롣
 *	ʥץꥱ˰¸
 *	
 *	ӥåȳƤͥ٤γɽȤɽȤۤʤΤǡ
 *	դ뤳ȡȿžƤ뤬ӥåȥեȤƤʤ
 *	
 *	ơ֥int_iipm_tbl[]˳ǼͤΥӥåȳơ
 *	ӥå03IPRXXꤹӥåȥѥ
 *	ʳͥ٥
 *	ӥå7NOT_CFG_INT_BIT
 *	0:CFG_INTǳͥ٤ꤵƤ롣
 *	1:CFG_INTǳͥ٤ꤵƤʤ
 */
extern const uint8_t int_iipm_tbl[TNUM_INT];

/*	CFG_INTǳͥ٤ꤵƤʤȤ򼨤ӥå  */
#define NOT_CFG_INT_BIT		0x80U

/*
 * ͥ٥쥸
 */
Inline void
irc_set_ipr(uint32_t address, uint32_t offset, uint32_t val)
{
	uint32_t ipr_val;

	ipr_val = sil_reh_mem((uint16_t *)address);
	ipr_val &= ~(0x0FU << offset);
	ipr_val |= val << offset;
	sil_wrh_mem((uint16_t *)address, ipr_val);
}

/*
 *	׵ػߥե饰Υå
 *
 *	ͥ٥쥸(IPRx)0ꤹ롥
 *
 *	°ꤵƤʤ׵饤ФƳ׵ػ
 *	ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_disable_int(INTNO intno)
{
	uint32_t iintno  = INT_INTNO(intno);
	uint32_t address = ipr_info_tbl[iintno].address;
	uint32_t offset  = ipr_info_tbl[iintno].offset;
	uint32_t iipm	 = int_iipm_tbl[iintno];
	
	/*	ǥå뤳ȤϡθƤʤ	*/
	assert(x_sense_lock());

	/*
	 *	°ꤵƤʤ
	 */
	if ((iipm & NOT_CFG_INT_BIT) != 0) {
		return(false);
	}
	
	/*
	 *	ֹбIPRͤ0ˤ롥
	 */
	irc_set_ipr(address, offset, 0x00);

	return(true);
}

#define t_disable_int(intno) x_disable_int(intno)
#define i_disable_int(intno) x_disable_int(intno)

/*
 *	׵ػߥե饰β
 *
 *	ͥ٥쥸(IPRx)򸵤᤹ͤ
 *
 *	°ꤵƤʤ׵饤ФƳ׵ػ
 *	ե饰򥯥ꥢ褦Ȥˤϡfalse֤
 */
Inline bool_t
x_enable_int(INTNO intno)
{
	uint32_t iintno  = INT_INTNO(intno);
	uint32_t address = ipr_info_tbl[iintno].address;
	uint32_t offset  = ipr_info_tbl[iintno].offset;
	uint32_t iipm	 = int_iipm_tbl[iintno];

	/*	ǥå뤳ȤϡθƤʤ	*/
	assert(x_sense_lock());

	/*
	 *	°ꤵƤʤ
	 */
	if ((iipm & NOT_CFG_INT_BIT) != 0) {
		return(false);
	}

	/*
	 *	ֹбIPRͤ򥻥åȤ
	 */
	irc_set_ipr(address, offset, (iipm & 0x0FU));
	
	return(true);
}

#define t_enable_int(intno) x_enable_int(intno)
#define i_enable_int(intno) x_enable_int(intno)

/*
 *	׵饤°
 *
 *	SH12AǤϡͥǰͥ٤16ʳǤ뤿ᡤintpri
 *	ȤͿ뤳ȤǤͤ-15-1ɸǤ롥
 *	
 *	SH12Aγߤϡ¢ե⥸塼ߡIRQߤʬǤ
 *	줾찷ۤʤ롥Τᡤֹ椫顤ɤγߤʬह
 *	ΥޥINTNO_IS_IRQ(intno)򥳥¸Ѱդ롥
 *	ϤΥե٤¸Τshx_config.h
 *	x_config_intatr()ǻѤ뤿ᡢshx_config.h˵ҤƤ롣
 */
extern void    x_config_int(INTNO intno, ATR intatr, PRI intpri);

/*
 *	ߥϥɥνиɬפIRC
 *	ɬפIRCi_begin_int()ϡ¸
 */
Inline void
i_end_int(INTNO intno)
{
}
#endif /* TOPPERS_MACRO_ONLY */

/*
 *	CPU㳰ϥɥط
 */

/*
 *	㳰ϥɥ p_excinf ƼФΥޥ
 */
#define P_EXCINF_OFFSET_VECTOR UINT_C( 0)
#define P_EXCINF_OFFSET_PR	   UINT_C( 1)
#define P_EXCINF_OFFSET_PC	   UINT_C(12)
#define P_EXCINF_OFFSET_SR	   UINT_C(13)

#define P_EXCINF_OFFSET_R0	   UINT_C( 4)

/*	CPU㳰ȯΥåݥ󥿤ͤp_excinfκʬ  */
#define P_EXCINF_OFFSET_SP	   (P_EXCINF_OFFSET_SR + 1)


#ifndef TOPPERS_MACRO_ONLY
/*
 *	CPU㳰ϥɥ
 */
Inline void
x_define_exc(EXCNO excno, FP exc_entry)
{
	assert(VALID_EXCNO_DEFEXC(excno));
}

/*
 *	CPU㳰ϥɥޥ
 */
#define EXC_ENTRY(excno, exchdr)	 _kernel_##exchdr##_##excno
#define EXCHDR_ENTRY(excno, excno_num, exchdr)					\
		extern void _kernel_##exchdr##_##excno(void *sp);

/*
 *	CPU㳰ȯΥƥȤλ
 *
 *	CPU㳰ȯΥƥȤƥȤλfalse
 *	Ǥʤtrue֤
 */
Inline bool_t
exc_sense_context(void *p_excinf)
{
	return(excnest_count > 1U);
}

/*
 *	CPU㳰ȯIPMʥϡɥγͥ٥ޥɽ
 *	ˤλ
 */
Inline uint32_t
exc_get_iipm(void *p_excinf)
{
	uint32_t *sp = (uint32_t *)p_excinf;
	uint32_t sr = *(sp + P_EXCINF_OFFSET_SR);
	uint32_t iimp = sr & 0x00F0U;
	return(iimp);
}

/*
 *	CPU㳰ȯΥƥȤȳߤΥޥ֤λ
 *
 *	CPU㳰ȯΥƥ֤
 *	ͥ¹Ǥʤ
 *	ƥȤǤꡤ
 *	ߥå֤Ǥʤ
 *	CPUå֤Ǥʤ
 *	ʥǥΡ˳ͥ٥ޥ
 *	ǤtrueǤʤfalse֤CPU㳰ͥ
 *	γ߽ȯˤfalse֤ˡ
 *
 *	SH12AǤϡCPU㳰ȯIPMʥϡɥγͥ٥
 *	ˤ٤ƤγߤĤ֤Ǥ뤳Ȥå뤳Ȥǡ
 *	ͥ¹Ǥʤȡ
 *	ߥå֤Ǥʤȡ
 *	CPUå֤Ǥʤȡ
 *	ʥǥΡ˳ͥ٥ޥ֤Ǥ뤳
 *	4Ĥξå뤳ȤǤCPU㳰ȯ
 *	lock_flag򻲾ȤɬפϤʤˡ
 */
Inline bool_t
exc_sense_intmask(void *p_excinf)
{
	return(!exc_sense_context(p_excinf)
					&& (exc_get_iipm(p_excinf) == IIPM_ENAALL));
}

/*
 * Trapaʳ㳰ϿƤʤ㳰ȯȸƤӽФ
 */
extern void default_exc_handler(void *p_excinf);

/*
 * ̤Ͽγߤȯ˸ƤӽФ
 * APIɸŪʤΤȰۤʤ뤿ᡢ桼ѰդΤ
 * ֤ϡץȥ롣
 */
#ifndef OMIT_DEFAULT_INT_HANDLER
extern void default_int_handler(INTNO intno);
#endif /* OMIT_DEFAULT_INT_HANDLER */

/*
 *	ץå¸ν
 */
extern void prc_initialize(void);

/*
 *	ץå¸νλ
 */
extern void prc_exit(void);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_PRC_CONFIG_H */
